#include <stdio.h>  
#include <stdlib.h>  
#include <unistd.h>
#include "bcsdk.h"



void on_DevstateUpdate(BC_STRUCT_DEVICE_STATE *pMsgInfo,unsigned int iMsgLen,unsigned long ulUserData)
{
	if(iMsgLen!=sizeof(BC_STRUCT_DEVICE_STATE))
		return;
	printf("[callback DevstateUpdate]sessionid=%d;state=%d\n",pMsgInfo->uiSessionID,pMsgInfo->uiState);
}

void on_FaceMsgcomplete(BC_STRUCT_FACEINFO *pMsgInfo,unsigned int iMsgLen,unsigned long ulUserData)
{
	int iret=0;
	if(iMsgLen!=sizeof(BC_STRUCT_FACEINFO))
		return;
	BC_STRUCT_FACEINFO *pinfo=(BC_STRUCT_FACEINFO *)pMsgInfo;
	//printf("[callback FaceMsgcomplete]faceID=%ld timestamp=%s id=%d\n",pinfo->faceID,pinfo->timestring,pinfo->uiSessionID);
	//printf("[callback FaceMsgcomplete] r=%d;l=%d;top=%d;bot=%d\n",pinfo->rect.left,pinfo->rect.right,pinfo->rect.top,pinfo->rect.bottom);
	char filename[256]={0};
	if(pinfo->bigpicbufsize>0)
	{
		snprintf(filename,sizeof(filename)-1,"./%d/b_%s_%ld.jpg",pinfo->uiSessionID,pinfo->timestring,pinfo->faceID);
		FILE * fp = fopen(filename,"w+");     
		if(fp)
		{
			iret = fwrite(pinfo->bigpicbuf,sizeof(char),pinfo->bigpicbufsize,fp);  
			printf("[callback FaceMsgcomplete]%d:receive bigpic and write %d to %s  realsize=%d\n",pMsgInfo->uiSessionID,iret,filename,pinfo->bigpicbufsize);			
			fclose(fp);
		}
		else
		    printf("File Open error:%s\n",filename);
		
	}
	if(pinfo->smallpicbufsize>0)
	{
		snprintf(filename,sizeof(filename)-1,"./%d/s_%s_%ld.jpg",pinfo->uiSessionID,pinfo->timestring,pinfo->faceID);
		FILE * fp = fopen(filename,"w+");    
		if(fp)
		{
			iret = fwrite(pinfo->smallpicbuf,sizeof(char),pinfo->smallpicbufsize,fp); 
			printf("[callback FaceMsgcomplete]%d,receive smallpic and write %d to %s realsize=%d\n",pMsgInfo->uiSessionID,iret,filename,pinfo->smallpicbufsize);			
			fclose(fp);
		}
		else
		    printf("File Open error:%s\n",filename);
		
	}
		
}


int main(int argc, char **argv)
{ 	
	int iret =-1;
	char pchVersion[64] = {0};
	char chCmd[100];
	iret=BC_Get_SDKVERSION(pchVersion,sizeof(pchVersion));	
	if(iret==0)
		printf("%s\n",pchVersion);

	
	BC_Set_LogFullPath("1.txt");
	unsigned long ulUserDate=100;
	BC_STRUCT_LOGININFO stLogininfo1={"192.168.6.100","admin","admin123",5000};
	BC_STRUCT_LOGININFO stLogininfo2={"192.168.6.101","admin","admin123",5000};
	BC_STRUCT_LOGININFO stLogininfo3={"192.168.6.34","admin","admin123",5000};
	BC_STRUCT_DEVICEINFO stDeviceinfo={0};
	iret = BC_Init_Sdk(on_FaceMsgcomplete,on_DevstateUpdate,ulUserDate);
	printf("[BC_Init_Sdk]ret=%d\n",iret);
	
	BC_Set_ListenIp("192.168.8.69");//must after BC_Init_Sdk,and before BC_Start_Listen
	
	iret = BC_Start_Listen(21789);
	printf("[BC_Start_Listen]iret=%d\n",iret);

	
	
	iret = BC_Device_Login(&stLogininfo1, &stDeviceinfo); 
	if(iret==0)
    {
        snprintf(chCmd,sizeof(chCmd),"mkdir -p %d",stDeviceinfo.uiDeviceSessionID);
        system(chCmd);
	
	}
	printf("[BC_Device_Login]login iret = %d deviceip=%s,id=%d\n",iret,stLogininfo1.sDeviceIP,stDeviceinfo.uiDeviceSessionID);

	unsigned int uiabliity=0;
	iret = BC_Get_DeviceAbility(stDeviceinfo.uiDeviceSessionID, &uiabliity);
	printf("[BC_Get_DeviceAbility]iret=%d;uiabliity=%d\n",iret,uiabliity);
#if 0
	iret = BC_Device_Login(&stLogininfo2, &stDeviceinfo); 
	if(iret==0)
    {
        snprintf(chCmd,sizeof(chCmd),"mkdir -p %d",stDeviceinfo.uiDeviceSessionID);
        system(chCmd);
	
	}
	printf("[BC_Device_Login]login iret = %d deviceip=%s,id=%d\n",iret,stLogininfo2.sDeviceIP,stDeviceinfo.uiDeviceSessionID);

	iret = BC_Device_Login(&stLogininfo3, &stDeviceinfo); 
	if(iret==0)
    {
        snprintf(chCmd,sizeof(chCmd),"mkdir -p %d",stDeviceinfo.uiDeviceSessionID);
        system(chCmd);
	
	}
	printf("[BC_Device_Login]login iret = %d deviceip=%s,id=%d\n",iret,stLogininfo3.sDeviceIP,stDeviceinfo.uiDeviceSessionID);
#endif
	while(1)
	{
		sleep(1000);

	}
	
	BC_Device_Logout(stDeviceinfo.uiDeviceSessionID);
	
	BC_Stop_Listen();
	
	BC_Uninit_Sdk();	
	return 0; 
}
